var _jsxFileName = "/var/apps/ah-form-builder/src/components/app/App.js";

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import { connect } from 'react-redux';
import CircularProgress from '@material-ui/core/CircularProgress';
import { setInitialData as _setInitialData, setPredefinedValues as _setPredefinedValues, setPredefinedEndpoint as _setPredefinedEndpoint, setFileUploadUrl as _setFileUploadUrl, setOrder as _setOrder, setConditionableFields as _setConditionableFields, createField as _createField } from '../../actions/formActions';
import MainLayout from '../../layouts/Main';
import predefined from '../../predefined-values';
import './App.scss';
import _ from 'lodash';
import axios from 'axios';
import Wrapper from './FieldWrapper';
import DroppableField from './DroppableField';
import { Scrollbars } from 'react-custom-scrollbars';
import { getHeight, generateSampleData } from '../../utils/helpers';

var compare = function compare(a, b) {
  if (a.order < b.order) {
    return -1;
  }

  if (a.order > b.order) {
    return 1;
  }

  return 0;
};

var App = /*#__PURE__*/function (_Component) {
  _inheritsLoose(App, _Component);

  function App(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleOnDragStart", function (index) {
      _this.onDragItem = index;
    });

    _defineProperty(_assertThisInitialized(_this), "handleOnDrop", function (index, type, uuid, order, event) {
      event.stopPropagation();
      var droppedFieldSlug = event.dataTransfer.getData('droppedFieldSlug');

      if (droppedFieldSlug) {
        if (type === 'section' && droppedFieldSlug !== 'section') {
          var data = generateSampleData(droppedFieldSlug, order);
          data.parentId = uuid;

          _this.props.createField(data);
        }
      } else {
        _this.onDropItem = index;

        _this.reorderFields(_this.onDragItem, _this.onDropItem);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleFieldDrop", function (e) {
      e.preventDefault();
      var droppedFieldSlug = e.dataTransfer.getData('droppedFieldSlug');

      if (droppedFieldSlug) {
        var data = generateSampleData(droppedFieldSlug, _this.props.order);

        _this.props.createField(data);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleFieldDropBtw", function (e, order, callback) {
      e.stopPropagation();
      var droppedFieldSlug = e.dataTransfer.getData('droppedFieldSlug');

      if (droppedFieldSlug) {
        var data = generateSampleData(droppedFieldSlug, order);

        _this.props.createField(data);
      }

      callback();
    });

    _defineProperty(_assertThisInitialized(_this), "renderFields", function () {
      _this.fields = Object.values(_this.props.data);

      var fields = _this.fields.filter(function (field) {
        if (field.parentId) return false;
        return true;
      });

      var count = 0;
      var total = fields.length;
      fields.sort(compare);
      return _.map(fields, function (field, index) {
        count++;
        return [/*#__PURE__*/React.createElement(DroppableField, {
          onDrop: _this.handleFieldDropBtw,
          order: field.order,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 127,
            columnNumber: 10
          }
        }), /*#__PURE__*/React.createElement("div", {
          draggable: "true",
          onDragStart: function onDragStart() {
            return _this.handleOnDragStart(index);
          },
          onDrop: function onDrop(e) {
            return _this.handleOnDrop(index, field.type, field.uuid, field.order, e);
          },
          onDragOver: function onDragOver(event) {
            return event.preventDefault();
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 128,
            columnNumber: 9
          }
        }, /*#__PURE__*/React.createElement("li", {
          key: 'li-' + field.uuid,
          className: "d-block",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 133,
            columnNumber: 9
          }
        }, /*#__PURE__*/React.createElement(Wrapper, {
          data: field,
          key: field.uuid,
          first: count === 1,
          last: count === total,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 134,
            columnNumber: 11
          }
        })))];
      });
    });

    _defineProperty(_assertThisInitialized(_this), "submitForm", function () {
      _this.props.onSubmit(_this.props.data);
    });

    _defineProperty(_assertThisInitialized(_this), "reorderFields", function (previousIndex, nextIndex) {
      var _this$fields;

      //reorder
      var dragItem = _this.fields.splice(previousIndex, 1);

      (_this$fields = _this.fields).splice.apply(_this$fields, [nextIndex, 0].concat(dragItem));

      var data = {};

      _this.fields.map(function (field, index) {
        field.order = index + 1;
        data[field.uuid] = field;
      });

      _this.props.setInitialData(data);
    });

    _this.fields = {};
    _this.state = {
      loading: true
    };
    _this.onDragItem = null;
    _this.onDropItem = null;
    return _this;
  }

  var _proto = App.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    console.log('did', this.props.predefinedEndpoint);

    if (this.props.conditionableFields) {
      this.props.setConditionableFields(this.props.conditionableFields);
    }

    if (_.size(this.props.data)) {
      var order = 1;

      _.map(this.props.data, function (field) {
        if (field.order > order) {
          order = field.order;
        }
      });

      this.props.setOrder(order + 1);
    }

    if (this.props.predefinedEndpoint) {
      axios.get(this.props.predefinedEndpoint).then(function (res) {
        _this2.props.setPredefinedValues(res.data);

        _this2.setState({
          loading: false
        }, function () {
          _this2.props.setPredefinedEndpoint(_this2.props.predefinedEndpoint);

          _this2.props.setFileUploadUrl(_this2.props.fileUploadUrl);

          _this2.props.setInitialData(_this2.props.formData);
        });
      })["catch"](function (err) {
        _this2.props.setPredefinedValues([]);

        _this2.setState({
          loading: false
        });

        console.error('Unable to fetch predefined options from ' + _this2.props.predefinedEndPoint);
      });
    }
  };

  _proto.render = function render() {
    var _this3 = this;

    if (this.state.loading) {
      return /*#__PURE__*/React.createElement(MainLayout, {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 163,
          columnNumber: 9
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: "width-full text-center pt-4",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 164,
          columnNumber: 11
        }
      }, /*#__PURE__*/React.createElement(CircularProgress, {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 165,
          columnNumber: 13
        }
      })));
    }

    if (_.size(this.props.data) > 0) {
      this.fields = Object.values(this.props.data);
      this.fields.sort(compare);
      return /*#__PURE__*/React.createElement(MainLayout, {
        onSubmit: this.submitForm,
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 174,
          columnNumber: 9
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: "content-pane-main position-relative",
        onDragOver: function onDragOver(e) {
          return e.preventDefault();
        },
        onDrop: function onDrop(e) {
          return _this3.handleFieldDrop(e);
        },
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 175,
          columnNumber: 13
        }
      }, /*#__PURE__*/React.createElement(Scrollbars, {
        style: {
          height: getHeight()
        },
        autoHide: true,
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 178,
          columnNumber: 15
        }
      }, this.renderFields()), /*#__PURE__*/React.createElement("div", {
        className: "width-full p-2",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 181,
          columnNumber: 15
        }
      })));
    } else {
      return /*#__PURE__*/React.createElement(MainLayout, {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 188,
          columnNumber: 9
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: "content-pane-main droppable-border",
        style: {
          height: getHeight()
        },
        onDragOver: function onDragOver(e) {
          return e.preventDefault();
        },
        onDrop: function onDrop(e) {
          return _this3.handleFieldDrop(e);
        },
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 189,
          columnNumber: 11
        }
      }, /*#__PURE__*/React.createElement("p", {
        className: "pt-5 text-center text-muted",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 192,
          columnNumber: 12
        }
      }, "Looks like there are no fields in this form")));
    }
  };

  return App;
}(Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    data: state.form.data,
    order: state.form.order
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    setPredefinedValues: function setPredefinedValues(data) {
      return dispatch(_setPredefinedValues(data));
    },
    setPredefinedEndpoint: function setPredefinedEndpoint(data) {
      return dispatch(_setPredefinedEndpoint(data));
    },
    setFileUploadUrl: function setFileUploadUrl(data) {
      return dispatch(_setFileUploadUrl(data));
    },
    setInitialData: function setInitialData(data) {
      return dispatch(_setInitialData(data));
    },
    setConditionableFields: function setConditionableFields(data) {
      return dispatch(_setConditionableFields(data));
    },
    setOrder: function setOrder(data) {
      return dispatch(_setOrder(data));
    },
    createField: function createField(data) {
      return dispatch(_createField(data));
    }
  };
};

export default connect(mapStateToProps, mapDispatchToProps)(App);