var _jsxFileName = "/var/apps/ah-form-builder/src/utils/choices/index.js";
import React, { useCallback } from 'react';
import FormLabel from "@material-ui/core/FormLabel";
import FormControl from "@material-ui/core/FormControl";
import { makeStyles } from '@material-ui/core/styles';
import FormHelperText from "@material-ui/core/FormHelperText";
import IconButton from "@material-ui/core/IconButton";
import DragIcon from '@material-ui/icons/DragIndicator';
import AddIcon from '@material-ui/icons/AddCircleOutline';
import RemoveIcon from '@material-ui/icons/RemoveCircleOutline';
import TextInput from "../inputs/TextInput";
import { List, ListItem, ListItemIcon } from "@material-ui/core";
import _ from 'lodash';
import DoneIcon from '@material-ui/icons/Done';
import CancelIcon from '@material-ui/icons/Cancel';
import './style.scss';
import { stringToSlug } from "../helpers";
import ChoiceItem from "./ChoiceItem";
import { Scrollbars } from 'react-custom-scrollbars';
import axios from 'axios';
import { updateCategoryOptions as _updateCategoryOptions } from '../../actions/predefinedActions';
import { connect } from 'react-redux';
var useStyles = makeStyles(function (theme) {
  return {
    labelRoot: {
      transform: 'none'
    }
  };
});

function Choices(props) {
  var _this = this;

  var error = props.error,
      required = props.required,
      label = props.label;

  var _React$useState = React.useState(null),
      name = _React$useState[0],
      setName = _React$useState[1];

  var _React$useState2 = React.useState(null),
      value = _React$useState2[0],
      setValue = _React$useState2[1];

  var _React$useState3 = React.useState(null),
      index = _React$useState3[0],
      setIndex = _React$useState3[1];

  var _React$useState4 = React.useState(''),
      labelError = _React$useState4[0],
      setLabelError = _React$useState4[1];

  var classes = useStyles();
  var newField = false;
  var predefined = {
    options: []
  };

  if (props.optionReferenceId) {
    for (var i = 0; i < props.predefined.length; i++) {
      if (props.predefined[i].id === props.optionReferenceId) {
        predefined = props.predefined[i];
        break;
      }
    }
  }

  if (predefined.options.length === 0) {
    newField = true;
  }

  var _handleChange = function handleChange(val, name) {
    if (name === 'name') {
      setName(val);
    } else if (name === 'value') {
      setValue(val);
    } else {
      setIndex(val);
    }

    setLabelError('');
  };

  var addNewChoice = function addNewChoice(e) {
    e.preventDefault();
    actionPerformed().then(function (resPredefined) {
      var url = '/predefined';

      if (props.predefinedEndpoint) {
        url = props.predefinedEndpoint;
      }

      axios.post(url + '/' + resPredefined.id + '/options', {
        name: name,
        value: value
      }).then(function (res) {
        props.updateCategoryOptions(res.data.options, resPredefined.slug);
        disableNewChoice();
      });
    });
  };

  var deleteChoice = function deleteChoice(optionId) {
    actionPerformed().then(function (resPredefined) {
      var url = '/predefined';

      if (props.predefinedEndpoint) {
        url = props.predefinedEndpoint;
      }

      axios["delete"](url + '/' + resPredefined.id + '/options/' + optionId).then(function (res) {
        props.updateCategoryOptions(res.data.options, resPredefined.slug);
        disableNewChoice();
      });
    });
  };

  var disableNewChoice = function disableNewChoice() {
    setValue(null);
    setName(null);
    setIndex(null);
  };

  var actionPerformed = function actionPerformed() {
    return new Promise(function (resolve, reject) {
      if (predefined.is_public || !predefined.id) {
        props.disablePredefined().then(function (res) {
          resolve(res);
        });
      } else {
        resolve(predefined);
      }
    });
  };

  var _updateChoice = function updateChoice(label, oldLabel) {
    if (oldLabel !== label) {
      actionPerformed().then(function (resPredefined) {
        var newId = null;

        for (var _i = 0; _i < resPredefined.options.length; _i++) {
          if (resPredefined.options[_i].name === oldLabel) {
            newId = resPredefined.options[_i].id;
            break;
          }
        }

        var url = '/predefined';

        if (props.predefinedEndpoint) {
          url = props.predefinedEndpoint;
        }

        axios.put(url + '/' + resPredefined.id + '/options', {
          optionId: newId,
          data: {
            name: label
          }
        }).then(function (res) {
          props.updateCategoryOptions(res.data.options, resPredefined.slug);
          disableNewChoice();
        });
      });
    }
  };

  var renderAddChoice = function renderAddChoice() {
    return /*#__PURE__*/React.createElement("form", {
      onSubmit: addNewChoice,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 143,
        columnNumber: 7
      }
    }, /*#__PURE__*/React.createElement("div", {
      className: "row",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 144,
        columnNumber: 9
      }
    }, /*#__PURE__*/React.createElement("div", {
      className: "col-md-5 pr-1",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 145,
        columnNumber: 11
      }
    }, /*#__PURE__*/React.createElement(TextInput, {
      placeholder: "New Label",
      error: labelError,
      value: name,
      handleChange: function handleChange(e) {
        return _handleChange(e.target.value, 'name');
      },
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 146,
        columnNumber: 13
      }
    })), /*#__PURE__*/React.createElement("div", {
      className: "col-md-5 px-1",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 148,
        columnNumber: 11
      }
    }, /*#__PURE__*/React.createElement(TextInput, {
      placeholder: "New Value",
      value: value,
      handleChange: function handleChange(e) {
        return _handleChange(e.target.value, 'value');
      },
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 149,
        columnNumber: 13
      }
    })), /*#__PURE__*/React.createElement("div", {
      className: "col-md-2 d-flex pl-1",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 151,
        columnNumber: 11
      }
    }, /*#__PURE__*/React.createElement(IconButton, {
      size: "small",
      onClick: addNewChoice,
      type: "submit",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 152,
        columnNumber: 13
      }
    }, /*#__PURE__*/React.createElement(DoneIcon, {
      fontSize: "small",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 153,
        columnNumber: 15
      }
    })), !newField ? /*#__PURE__*/React.createElement(IconButton, {
      size: "small",
      onClick: disableNewChoice,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 156,
        columnNumber: 15
      }
    }, /*#__PURE__*/React.createElement(CancelIcon, {
      fontSize: "small",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 157,
        columnNumber: 17
      }
    })) : "")));
  };

  var renderChoices = function renderChoices() {
    return predefined.options.map(function (choice, listIndex) {
      if (listIndex === index) {
        return /*#__PURE__*/React.createElement(React.Fragment, {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 170,
            columnNumber: 11
          }
        }, /*#__PURE__*/React.createElement(ListItem, {
          disableGutters: true,
          className: "py-0 width-98p",
          key: choice.id + '-new',
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 171,
            columnNumber: 13
          }
        }, renderAddChoice()), /*#__PURE__*/React.createElement(ListItem, {
          disableGutters: true,
          className: "py-0",
          key: choice.id,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 174,
            columnNumber: 13
          }
        }, /*#__PURE__*/React.createElement(ChoiceItem, {
          label: choice.name,
          updateChoice: function updateChoice(value) {
            return _updateChoice(value, choice.name);
          },
          index: listIndex,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 178,
            columnNumber: 15
          }
        }), /*#__PURE__*/React.createElement(IconButton, {
          size: "small",
          className: "mt-3",
          onClick: function onClick(e) {
            return _handleChange(listIndex + 1, 'index');
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 179,
            columnNumber: 15
          }
        }, /*#__PURE__*/React.createElement(AddIcon, {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 179,
            columnNumber: 107
          }
        })), /*#__PURE__*/React.createElement(IconButton, {
          size: "small",
          className: "mt-3",
          onClick: function onClick(e) {
            return deleteChoice(choice.id);
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 180,
            columnNumber: 15
          }
        }, /*#__PURE__*/React.createElement(RemoveIcon, {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 180,
            columnNumber: 96
          }
        }))));
      } else if (index === predefined.options.length && listIndex === predefined.options.length - 1) {
        return /*#__PURE__*/React.createElement(React.Fragment, {
          key: choice.name,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 186,
            columnNumber: 11
          }
        }, /*#__PURE__*/React.createElement(ListItem, {
          disableGutters: true,
          className: "py-0 width-98p",
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 187,
            columnNumber: 13
          }
        }, /*#__PURE__*/React.createElement(ChoiceItem, {
          label: choice.name,
          updateChoice: function updateChoice(value) {
            return _updateChoice(value, choice.name);
          },
          index: listIndex,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 191,
            columnNumber: 15
          }
        }), /*#__PURE__*/React.createElement(IconButton, {
          size: "small",
          className: "mt-3",
          onClick: function onClick(e) {
            return _handleChange(listIndex + 1, 'index');
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 192,
            columnNumber: 15
          }
        }, /*#__PURE__*/React.createElement(AddIcon, {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 192,
            columnNumber: 107
          }
        })), /*#__PURE__*/React.createElement(IconButton, {
          size: "small",
          className: "mt-3",
          onClick: function onClick(e) {
            return deleteChoice(choice.id);
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 193,
            columnNumber: 15
          }
        }, /*#__PURE__*/React.createElement(RemoveIcon, {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 193,
            columnNumber: 96
          }
        }))), /*#__PURE__*/React.createElement(ListItem, {
          disableGutters: true,
          className: "py-0 width-98p",
          key: choice.name + '-new',
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 195,
            columnNumber: 13
          }
        }, renderAddChoice()));
      } else {
        return /*#__PURE__*/React.createElement(ListItem, {
          disableGutters: true,
          className: "py-0 width-98p",
          key: choice.name,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 202,
            columnNumber: 11
          }
        }, /*#__PURE__*/React.createElement(ChoiceItem, {
          label: choice.name,
          updateChoice: function updateChoice(value) {
            return _updateChoice(value, choice.name);
          },
          index: listIndex,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 206,
            columnNumber: 13
          }
        }), /*#__PURE__*/React.createElement(IconButton, {
          size: "small",
          className: "mt-3",
          onClick: function onClick(e) {
            return _handleChange(listIndex + 1, 'index');
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 207,
            columnNumber: 13
          }
        }, /*#__PURE__*/React.createElement(AddIcon, {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 207,
            columnNumber: 105
          }
        })), /*#__PURE__*/React.createElement(IconButton, {
          size: "small",
          className: "mt-3",
          onClick: function onClick(e) {
            return deleteChoice(choice.id);
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 208,
            columnNumber: 13
          }
        }, /*#__PURE__*/React.createElement(RemoveIcon, {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 208,
            columnNumber: 94
          }
        })));
      }
    });
  };

  return /*#__PURE__*/React.createElement(FormControl, {
    error: !!error,
    fullWidth: true,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 216,
      columnNumber: 5
    }
  }, /*#__PURE__*/React.createElement(FormLabel, {
    required: required,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 217,
      columnNumber: 7
    }
  }, label), newField ? renderAddChoice() : /*#__PURE__*/React.createElement(List, {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 219,
      columnNumber: 9
    }
  }, /*#__PURE__*/React.createElement(Scrollbars, {
    autoHeight: true,
    autoHeightMax: 200,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 220,
      columnNumber: 11
    }
  }, renderChoices())), !!error ? /*#__PURE__*/React.createElement(FormHelperText, {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 226,
      columnNumber: 9
    }
  }, error) : "");
}

var mapStateToProps = function mapStateToProps(state) {
  return {
    predefinedEndpoint: state.form.predefinedEndpoint
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    updateCategoryOptions: function updateCategoryOptions(data, slug) {
      return dispatch(_updateCategoryOptions(data, slug));
    }
  };
};

export default connect(mapStateToProps, mapDispatchToProps)(Choices);