"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _CircularProgress = _interopRequireDefault(require("@material-ui/core/CircularProgress"));

var _formActions = require("../../actions/formActions");

var _Main = _interopRequireDefault(require("../../layouts/Main"));

var _predefinedValues = _interopRequireDefault(require("../../predefined-values"));

require("./App.scss");

var _lodash = _interopRequireDefault(require("lodash"));

var _axios = _interopRequireDefault(require("axios"));

var _FieldWrapper = _interopRequireDefault(require("./FieldWrapper"));

var _DroppableField = _interopRequireDefault(require("./DroppableField"));

var _reactCustomScrollbars = require("react-custom-scrollbars");

var _helpers = require("../../utils/helpers");

var _jsxFileName = "/var/apps/ah-form-builder/src/components/app/App.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var compare = function compare(a, b) {
  if (a.order < b.order) {
    return -1;
  }

  if (a.order > b.order) {
    return 1;
  }

  return 0;
};

var App = /*#__PURE__*/function (_Component) {
  _inheritsLoose(App, _Component);

  function App(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleOnDragStart", function (index) {
      _this.onDragItem = index;
    });

    _defineProperty(_assertThisInitialized(_this), "handleOnDrop", function (index, type, uuid, order, event) {
      event.stopPropagation();
      var droppedFieldSlug = event.dataTransfer.getData('droppedFieldSlug');

      if (droppedFieldSlug) {
        if (type === 'section' && droppedFieldSlug !== 'section') {
          var data = (0, _helpers.generateSampleData)(droppedFieldSlug, order);
          data.parentId = uuid;

          _this.props.createField(data);
        }
      } else {
        _this.onDropItem = index;

        _this.reorderFields(_this.onDragItem, _this.onDropItem);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleFieldDrop", function (e) {
      e.preventDefault();
      var droppedFieldSlug = e.dataTransfer.getData('droppedFieldSlug');

      if (droppedFieldSlug) {
        var data = (0, _helpers.generateSampleData)(droppedFieldSlug, _this.props.order);

        _this.props.createField(data);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleFieldDropBtw", function (e, order, callback) {
      e.stopPropagation();
      var droppedFieldSlug = e.dataTransfer.getData('droppedFieldSlug');

      if (droppedFieldSlug) {
        var data = (0, _helpers.generateSampleData)(droppedFieldSlug, order);

        _this.props.createField(data);
      }

      callback();
    });

    _defineProperty(_assertThisInitialized(_this), "renderFields", function () {
      _this.fields = Object.values(_this.props.data);

      var fields = _this.fields.filter(function (field) {
        if (field.parentId) return false;
        return true;
      });

      var count = 0;
      var total = fields.length;
      fields.sort(compare);
      return _lodash["default"].map(fields, function (field, index) {
        count++;
        return [/*#__PURE__*/_react["default"].createElement(_DroppableField["default"], {
          onDrop: _this.handleFieldDropBtw,
          order: field.order,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 127,
            columnNumber: 10
          }
        }), /*#__PURE__*/_react["default"].createElement("div", {
          draggable: "true",
          onDragStart: function onDragStart() {
            return _this.handleOnDragStart(index);
          },
          onDrop: function onDrop(e) {
            return _this.handleOnDrop(index, field.type, field.uuid, field.order, e);
          },
          onDragOver: function onDragOver(event) {
            return event.preventDefault();
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 128,
            columnNumber: 9
          }
        }, /*#__PURE__*/_react["default"].createElement("li", {
          key: 'li-' + field.uuid,
          className: "d-block",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 133,
            columnNumber: 9
          }
        }, /*#__PURE__*/_react["default"].createElement(_FieldWrapper["default"], {
          data: field,
          key: field.uuid,
          first: count === 1,
          last: count === total,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 134,
            columnNumber: 11
          }
        })))];
      });
    });

    _defineProperty(_assertThisInitialized(_this), "submitForm", function () {
      _this.props.onSubmit(_this.props.data);
    });

    _defineProperty(_assertThisInitialized(_this), "reorderFields", function (previousIndex, nextIndex) {
      var _this$fields;

      //reorder
      var dragItem = _this.fields.splice(previousIndex, 1);

      (_this$fields = _this.fields).splice.apply(_this$fields, [nextIndex, 0].concat(dragItem));

      var data = {};

      _this.fields.map(function (field, index) {
        field.order = index + 1;
        data[field.uuid] = field;
      });

      _this.props.setInitialData(data);
    });

    _this.fields = {};
    _this.state = {
      loading: true
    };
    _this.onDragItem = null;
    _this.onDropItem = null;
    return _this;
  }

  var _proto = App.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    console.log('did', this.props.predefinedEndpoint);

    if (this.props.conditionableFields) {
      this.props.setConditionableFields(this.props.conditionableFields);
    }

    if (_lodash["default"].size(this.props.data)) {
      var order = 1;

      _lodash["default"].map(this.props.data, function (field) {
        if (field.order > order) {
          order = field.order;
        }
      });

      this.props.setOrder(order + 1);
    }

    if (this.props.predefinedEndpoint) {
      _axios["default"].get(this.props.predefinedEndpoint).then(function (res) {
        _this2.props.setPredefinedValues(res.data);

        _this2.setState({
          loading: false
        }, function () {
          _this2.props.setPredefinedEndpoint(_this2.props.predefinedEndpoint);

          _this2.props.setFileUploadUrl(_this2.props.fileUploadUrl);

          _this2.props.setInitialData(_this2.props.formData);
        });
      })["catch"](function (err) {
        _this2.props.setPredefinedValues([]);

        _this2.setState({
          loading: false
        });

        console.error('Unable to fetch predefined options from ' + _this2.props.predefinedEndPoint);
      });
    }
  };

  _proto.render = function render() {
    var _this3 = this;

    if (this.state.loading) {
      return /*#__PURE__*/_react["default"].createElement(_Main["default"], {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 163,
          columnNumber: 9
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "width-full text-center pt-4",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 164,
          columnNumber: 11
        }
      }, /*#__PURE__*/_react["default"].createElement(_CircularProgress["default"], {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 165,
          columnNumber: 13
        }
      })));
    }

    if (_lodash["default"].size(this.props.data) > 0) {
      this.fields = Object.values(this.props.data);
      this.fields.sort(compare);
      return /*#__PURE__*/_react["default"].createElement(_Main["default"], {
        onSubmit: this.submitForm,
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 174,
          columnNumber: 9
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "content-pane-main position-relative",
        onDragOver: function onDragOver(e) {
          return e.preventDefault();
        },
        onDrop: function onDrop(e) {
          return _this3.handleFieldDrop(e);
        },
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 175,
          columnNumber: 13
        }
      }, /*#__PURE__*/_react["default"].createElement(_reactCustomScrollbars.Scrollbars, {
        style: {
          height: (0, _helpers.getHeight)()
        },
        autoHide: true,
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 178,
          columnNumber: 15
        }
      }, this.renderFields()), /*#__PURE__*/_react["default"].createElement("div", {
        className: "width-full p-2",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 181,
          columnNumber: 15
        }
      })));
    } else {
      return /*#__PURE__*/_react["default"].createElement(_Main["default"], {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 188,
          columnNumber: 9
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "content-pane-main droppable-border",
        style: {
          height: (0, _helpers.getHeight)()
        },
        onDragOver: function onDragOver(e) {
          return e.preventDefault();
        },
        onDrop: function onDrop(e) {
          return _this3.handleFieldDrop(e);
        },
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 189,
          columnNumber: 11
        }
      }, /*#__PURE__*/_react["default"].createElement("p", {
        className: "pt-5 text-center text-muted",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 192,
          columnNumber: 12
        }
      }, "Looks like there are no fields in this form")));
    }
  };

  return App;
}(_react.Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    data: state.form.data,
    order: state.form.order
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    setPredefinedValues: function setPredefinedValues(data) {
      return dispatch((0, _formActions.setPredefinedValues)(data));
    },
    setPredefinedEndpoint: function setPredefinedEndpoint(data) {
      return dispatch((0, _formActions.setPredefinedEndpoint)(data));
    },
    setFileUploadUrl: function setFileUploadUrl(data) {
      return dispatch((0, _formActions.setFileUploadUrl)(data));
    },
    setInitialData: function setInitialData(data) {
      return dispatch((0, _formActions.setInitialData)(data));
    },
    setConditionableFields: function setConditionableFields(data) {
      return dispatch((0, _formActions.setConditionableFields)(data));
    },
    setOrder: function setOrder(data) {
      return dispatch((0, _formActions.setOrder)(data));
    },
    createField: function createField(data) {
      return dispatch((0, _formActions.createField)(data));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(App);

exports["default"] = _default;
module.exports = exports.default;