"use strict";

exports.__esModule = true;
exports["default"] = PersistentDrawerRight;

var _react = _interopRequireWildcard(require("react"));

var _styles = require("@material-ui/core/styles");

var _Drawer = _interopRequireDefault(require("@material-ui/core/Drawer"));

var _AppBar = _interopRequireDefault(require("@material-ui/core/AppBar"));

var _Toolbar = _interopRequireDefault(require("@material-ui/core/Toolbar"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _Paper = _interopRequireDefault(require("@material-ui/core/Paper"));

var _jsxFileName = "/var/apps/ah-form-builder/src/components/toolbar/Drawer.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    titleCenter: {
      flexGrow: 1,
      textAlign: 'center'
    },
    titleWithAction: {
      flexGrow: 1
    },
    drawerPaper: {
      width: '32%'
    }
  };
});

function PersistentDrawerRight(props) {
  var classes = useStyles();
  (0, _react.useEffect)(function () {
    window.onscroll = function () {
      fixToolbar();
    };
  });

  var fixToolbar = function fixToolbar() {
    var header = document.getElementById("toolbar-main");
    var sticky = header.offsetTop;

    if (window.pageYOffset > sticky) {
      header.classList.add("sticky");
    } else {
      header.classList.remove("sticky");
    }
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "toolbar-main",
    id: "toolbar-main",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 41,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement(_AppBar["default"], {
    className: "position-static",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 42,
      columnNumber: 7
    }
  }, /*#__PURE__*/_react["default"].createElement(_Toolbar["default"], {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 43,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    variant: "h6",
    noWrap: true,
    className: !!props.rightIcon ? classes.titleWithAction : classes.titleCenter + " toolBarTitle",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 44,
      columnNumber: 11
    }
  }, props.title, !!props.rightIcon ? /*#__PURE__*/_react["default"].createElement("span", {
    className: "pull-right cursor-pointer",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 47,
      columnNumber: 15
    }
  }, props.rightIcon) : ""))), /*#__PURE__*/_react["default"].createElement(_Divider["default"], {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 52,
      columnNumber: 7
    }
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: props.type === 'fields' ? "toolbar-inner-paper toolbar-field-types" : "toolbar-inner-paper",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 53,
      columnNumber: 7
    }
  }, props.children));
}

module.exports = exports.default;