"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _App = _interopRequireDefault(require("./components/app/App"));

var _reactRedux = require("react-redux");

var _styles = require("@material-ui/core/styles");

var _colors = require("@material-ui/core/colors");

require("./styles/index.scss");

require("bootstrap/dist/css/bootstrap.css");

var _redux = require("redux");

var _rootReducer = _interopRequireDefault(require("./reducers/rootReducer"));

var _reduxThunk = _interopRequireDefault(require("redux-thunk"));

var _jsxFileName = "/var/apps/ah-form-builder/src/index.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var theme = (0, _styles.createMuiTheme)({
  palette: {
    primary: {
      main: _colors.blue[700]
    }
  }
});

var FormBuilder = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(FormBuilder, _React$Component);

  function FormBuilder() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "state", {
      loading: true
    });

    return _this;
  }

  var _proto = FormBuilder.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    setTimeout(function () {
      _this2.setState({
        loading: false
      });
    }, 1000);
  };

  _proto.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState, nextContext) {
    return this.state.loading;
  };

  _proto.render = function render() {
    if (this.state.loading) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 40,
          columnNumber: 9
        }
      }, "Loading...");
    }

    return /*#__PURE__*/_react["default"].createElement(_reactRedux.Provider, {
      store: (0, _redux.createStore)(_rootReducer["default"], (0, _redux.applyMiddleware)(_reduxThunk["default"])),
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 46,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "container-el",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 50,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react["default"].createElement(_App["default"], {
      onSubmit: this.props.onSubmit,
      formData: this.props.data,
      predefinedEndpoint: this.props.predefinedEndpoint,
      fileUploadUrl: this.props.fileUploadUrl,
      conditionableFields: this.props.conditionableFields,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 51,
        columnNumber: 11
      }
    })));
  };

  return FormBuilder;
}(_react["default"].Component);

var _default = FormBuilder;
exports["default"] = _default;
module.exports = exports.default;