"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _FormLabel = _interopRequireDefault(require("@material-ui/core/FormLabel"));

var _FormControl = _interopRequireDefault(require("@material-ui/core/FormControl"));

var _styles = require("@material-ui/core/styles");

var _FormHelperText = _interopRequireDefault(require("@material-ui/core/FormHelperText"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _DragIndicator = _interopRequireDefault(require("@material-ui/icons/DragIndicator"));

var _AddCircleOutline = _interopRequireDefault(require("@material-ui/icons/AddCircleOutline"));

var _RemoveCircleOutline = _interopRequireDefault(require("@material-ui/icons/RemoveCircleOutline"));

var _TextInput = _interopRequireDefault(require("../inputs/TextInput"));

var _core = require("@material-ui/core");

var _lodash = _interopRequireDefault(require("lodash"));

var _Done = _interopRequireDefault(require("@material-ui/icons/Done"));

var _Cancel = _interopRequireDefault(require("@material-ui/icons/Cancel"));

require("./style.scss");

var _helpers = require("../helpers");

var _ChoiceItem = _interopRequireDefault(require("./ChoiceItem"));

var _reactCustomScrollbars = require("react-custom-scrollbars");

var _axios = _interopRequireDefault(require("axios"));

var _predefinedActions = require("../../actions/predefinedActions");

var _reactRedux = require("react-redux");

var _jsxFileName = "/var/apps/ah-form-builder/src/utils/choices/index.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    labelRoot: {
      transform: 'none'
    }
  };
});

function Choices(props) {
  var _this = this;

  var error = props.error,
      required = props.required,
      label = props.label;

  var _React$useState = _react["default"].useState(null),
      name = _React$useState[0],
      setName = _React$useState[1];

  var _React$useState2 = _react["default"].useState(null),
      value = _React$useState2[0],
      setValue = _React$useState2[1];

  var _React$useState3 = _react["default"].useState(null),
      index = _React$useState3[0],
      setIndex = _React$useState3[1];

  var _React$useState4 = _react["default"].useState(''),
      labelError = _React$useState4[0],
      setLabelError = _React$useState4[1];

  var classes = useStyles();
  var newField = false;
  var predefined = {
    options: []
  };

  if (props.optionReferenceId) {
    for (var i = 0; i < props.predefined.length; i++) {
      if (props.predefined[i].id === props.optionReferenceId) {
        predefined = props.predefined[i];
        break;
      }
    }
  }

  if (predefined.options.length === 0) {
    newField = true;
  }

  var _handleChange = function handleChange(val, name) {
    if (name === 'name') {
      setName(val);
    } else if (name === 'value') {
      setValue(val);
    } else {
      setIndex(val);
    }

    setLabelError('');
  };

  var addNewChoice = function addNewChoice(e) {
    e.preventDefault();
    actionPerformed().then(function (resPredefined) {
      var url = '/predefined';

      if (props.predefinedEndpoint) {
        url = props.predefinedEndpoint;
      }

      _axios["default"].post(url + '/' + resPredefined.id + '/options', {
        name: name,
        value: value
      }).then(function (res) {
        props.updateCategoryOptions(res.data.options, resPredefined.slug);
        disableNewChoice();
      });
    });
  };

  var deleteChoice = function deleteChoice(optionId) {
    actionPerformed().then(function (resPredefined) {
      var url = '/predefined';

      if (props.predefinedEndpoint) {
        url = props.predefinedEndpoint;
      }

      _axios["default"]["delete"](url + '/' + resPredefined.id + '/options/' + optionId).then(function (res) {
        props.updateCategoryOptions(res.data.options, resPredefined.slug);
        disableNewChoice();
      });
    });
  };

  var disableNewChoice = function disableNewChoice() {
    setValue(null);
    setName(null);
    setIndex(null);
  };

  var actionPerformed = function actionPerformed() {
    return new Promise(function (resolve, reject) {
      if (predefined.is_public || !predefined.id) {
        props.disablePredefined().then(function (res) {
          resolve(res);
        });
      } else {
        resolve(predefined);
      }
    });
  };

  var _updateChoice = function updateChoice(label, oldLabel) {
    if (oldLabel !== label) {
      actionPerformed().then(function (resPredefined) {
        var newId = null;

        for (var _i = 0; _i < resPredefined.options.length; _i++) {
          if (resPredefined.options[_i].name === oldLabel) {
            newId = resPredefined.options[_i].id;
            break;
          }
        }

        var url = '/predefined';

        if (props.predefinedEndpoint) {
          url = props.predefinedEndpoint;
        }

        _axios["default"].put(url + '/' + resPredefined.id + '/options', {
          optionId: newId,
          data: {
            name: label
          }
        }).then(function (res) {
          props.updateCategoryOptions(res.data.options, resPredefined.slug);
          disableNewChoice();
        });
      });
    }
  };

  var renderAddChoice = function renderAddChoice() {
    return /*#__PURE__*/_react["default"].createElement("form", {
      onSubmit: addNewChoice,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 143,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "row",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 144,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "col-md-5 pr-1",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 145,
        columnNumber: 11
      }
    }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
      placeholder: "New Label",
      error: labelError,
      value: name,
      handleChange: function handleChange(e) {
        return _handleChange(e.target.value, 'name');
      },
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 146,
        columnNumber: 13
      }
    })), /*#__PURE__*/_react["default"].createElement("div", {
      className: "col-md-5 px-1",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 148,
        columnNumber: 11
      }
    }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
      placeholder: "New Value",
      value: value,
      handleChange: function handleChange(e) {
        return _handleChange(e.target.value, 'value');
      },
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 149,
        columnNumber: 13
      }
    })), /*#__PURE__*/_react["default"].createElement("div", {
      className: "col-md-2 d-flex pl-1",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 151,
        columnNumber: 11
      }
    }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      size: "small",
      onClick: addNewChoice,
      type: "submit",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 152,
        columnNumber: 13
      }
    }, /*#__PURE__*/_react["default"].createElement(_Done["default"], {
      fontSize: "small",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 153,
        columnNumber: 15
      }
    })), !newField ? /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      size: "small",
      onClick: disableNewChoice,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 156,
        columnNumber: 15
      }
    }, /*#__PURE__*/_react["default"].createElement(_Cancel["default"], {
      fontSize: "small",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 157,
        columnNumber: 17
      }
    })) : "")));
  };

  var renderChoices = function renderChoices() {
    return predefined.options.map(function (choice, listIndex) {
      if (listIndex === index) {
        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 170,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_core.ListItem, {
          disableGutters: true,
          className: "py-0 width-98p",
          key: choice.id + '-new',
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 171,
            columnNumber: 13
          }
        }, renderAddChoice()), /*#__PURE__*/_react["default"].createElement(_core.ListItem, {
          disableGutters: true,
          className: "py-0",
          key: choice.id,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 174,
            columnNumber: 13
          }
        }, /*#__PURE__*/_react["default"].createElement(_ChoiceItem["default"], {
          label: choice.name,
          updateChoice: function updateChoice(value) {
            return _updateChoice(value, choice.name);
          },
          index: listIndex,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 178,
            columnNumber: 15
          }
        }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
          size: "small",
          className: "mt-3",
          onClick: function onClick(e) {
            return _handleChange(listIndex + 1, 'index');
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 179,
            columnNumber: 15
          }
        }, /*#__PURE__*/_react["default"].createElement(_AddCircleOutline["default"], {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 179,
            columnNumber: 107
          }
        })), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
          size: "small",
          className: "mt-3",
          onClick: function onClick(e) {
            return deleteChoice(choice.id);
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 180,
            columnNumber: 15
          }
        }, /*#__PURE__*/_react["default"].createElement(_RemoveCircleOutline["default"], {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 180,
            columnNumber: 96
          }
        }))));
      } else if (index === predefined.options.length && listIndex === predefined.options.length - 1) {
        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
          key: choice.name,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 186,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_core.ListItem, {
          disableGutters: true,
          className: "py-0 width-98p",
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 187,
            columnNumber: 13
          }
        }, /*#__PURE__*/_react["default"].createElement(_ChoiceItem["default"], {
          label: choice.name,
          updateChoice: function updateChoice(value) {
            return _updateChoice(value, choice.name);
          },
          index: listIndex,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 191,
            columnNumber: 15
          }
        }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
          size: "small",
          className: "mt-3",
          onClick: function onClick(e) {
            return _handleChange(listIndex + 1, 'index');
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 192,
            columnNumber: 15
          }
        }, /*#__PURE__*/_react["default"].createElement(_AddCircleOutline["default"], {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 192,
            columnNumber: 107
          }
        })), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
          size: "small",
          className: "mt-3",
          onClick: function onClick(e) {
            return deleteChoice(choice.id);
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 193,
            columnNumber: 15
          }
        }, /*#__PURE__*/_react["default"].createElement(_RemoveCircleOutline["default"], {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 193,
            columnNumber: 96
          }
        }))), /*#__PURE__*/_react["default"].createElement(_core.ListItem, {
          disableGutters: true,
          className: "py-0 width-98p",
          key: choice.name + '-new',
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 195,
            columnNumber: 13
          }
        }, renderAddChoice()));
      } else {
        return /*#__PURE__*/_react["default"].createElement(_core.ListItem, {
          disableGutters: true,
          className: "py-0 width-98p",
          key: choice.name,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 202,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_ChoiceItem["default"], {
          label: choice.name,
          updateChoice: function updateChoice(value) {
            return _updateChoice(value, choice.name);
          },
          index: listIndex,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 206,
            columnNumber: 13
          }
        }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
          size: "small",
          className: "mt-3",
          onClick: function onClick(e) {
            return _handleChange(listIndex + 1, 'index');
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 207,
            columnNumber: 13
          }
        }, /*#__PURE__*/_react["default"].createElement(_AddCircleOutline["default"], {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 207,
            columnNumber: 105
          }
        })), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
          size: "small",
          className: "mt-3",
          onClick: function onClick(e) {
            return deleteChoice(choice.id);
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 208,
            columnNumber: 13
          }
        }, /*#__PURE__*/_react["default"].createElement(_RemoveCircleOutline["default"], {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 208,
            columnNumber: 94
          }
        })));
      }
    });
  };

  return /*#__PURE__*/_react["default"].createElement(_FormControl["default"], {
    error: !!error,
    fullWidth: true,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 216,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement(_FormLabel["default"], {
    required: required,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 217,
      columnNumber: 7
    }
  }, label), newField ? renderAddChoice() : /*#__PURE__*/_react["default"].createElement(_core.List, {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 219,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react["default"].createElement(_reactCustomScrollbars.Scrollbars, {
    autoHeight: true,
    autoHeightMax: 200,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 220,
      columnNumber: 11
    }
  }, renderChoices())), !!error ? /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 226,
      columnNumber: 9
    }
  }, error) : "");
}

var mapStateToProps = function mapStateToProps(state) {
  return {
    predefinedEndpoint: state.form.predefinedEndpoint
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    updateCategoryOptions: function updateCategoryOptions(data, slug) {
      return dispatch((0, _predefinedActions.updateCategoryOptions)(data, slug));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Choices);

exports["default"] = _default;
module.exports = exports.default;